<?php
/**
 * @version		$Id: metacharactercount.php 20196 2011-03-04 02:40:25Z mrichey $
 * @package		plg_system_metacharactercount
 * @copyright	Copyright (C) 2005 - 2011 Michael Richey. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

class plgSystemMetaCharacterCount extends JPlugin
 {

    /**
     * @param	JForm	$form	The form to be altered.
     * @param	array	$data	The associated data for the form.
     *
     * @return	boolean
     * @since	1.6
     */
    function onContentPrepareForm($form) {
        if (!($form instanceof JForm)) return false; 
        
        jimport('joomla.version');
        $version = new JVersion();
        $version = explode('.',$version->getShortVersion());
        
        $validforms=array(
            'com_content.article'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',
                'articletext'=>'jform[articletext]'
            ),
            'com_menus.item'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',
                'params_menu_meta_description'=>'jform[params][menu-meta_description]',
                'params_menu_meta_keywords'=>'jform[params][menu-meta_keywords]',
                'params_page_title'=>'jform[params][page_title]'
            ),
            'com_categories.categorycom_content'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',
                'description'=>'jform[description]'
            ),
            'com_weblinks.weblink'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',      
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',    
                'description'=>'jform[description]'      
            ),
            'com_categories.categorycom_weblinks'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',
                'description'=>'jform[description]'
            ),
            'com_newsfeeds.newsfeed'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',      
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',    
                'description'=>'jform[description]'      
            ),
            'com_categories.categorycom_newsfeeds'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',
                'description'=>'jform[description]'
            ),
            'com_banners.banner'=>array(
                'name'=>'jform[name]',
                'alias'=>'jform[alias]',      
                'metakey'=>'jform[metakey]',    
                'description'=>'jform[description]'      
            ),
            'com_categories.categorycom_banners'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',
                'description'=>'jform[description]'
            ),
            'com_contact.contact'=>array(
                'name'=>'jform[name]',
                'alias'=>'jform[alias]',    
                'metadesc'=>'jform[metadesc]',  
                'metakey'=>'jform[metakey]',    
                'misc'=>'jform[misc]'      
            ),
            'com_categories.categorycom_contact'=>array(
                'title'=>'jform[title]',
                'alias'=>'jform[alias]',
                'metadesc'=>'jform[metadesc]',
                'metakey'=>'jform[metakey]',
                'description'=>'jform[description]'
            ),
            'com_config.application'=>array(
                'sitename'=>'jform[sitename]',
                'fromname'=>'jform[fromname]',
                'offline_message'=>'jform[offline_message]',
                'MetaDesc'=>'jform[MetaDesc]',
                'MetaKeys'=>'jform[MetaKeys]'
            ),
        );
        $periodicals=array(
            'com_content.article'=>array('articletext'),
            'com_categories.categorycom_content'=>array('description'),
            'com_categories.categorycom_weblinks'=>array('description'),
            'com_categories.categorycom_newsfeeds'=>array('description'),
            'com_categories.categorycom_banners'=>array('description'),
            'com_categories.categorycom_contact'=>array('description'),
        );
        $formname = $form->getName();
        if (!in_array($formname, array_keys($validforms))) return true;       
        JHtml::_('behavior.framework',true);
        $doc = JFactory::getDocument();
        $doc->addScript(JURI::root(true).'/media/plg_system_metacharactercount/js/word-count.js');
        $doc->addScript(JURI::root(true).'/media/plg_system_metacharactercount/js/metacharactercount.js');
	JFactory::getLanguage()->load('plg_system_metacharactercount',JPATH_ADMINISTRATOR);
        $config=array('fields'=>array(),'strings'=>array('CHARACTERS'=>JText::_('PLG_SYSTEM_METACHARACTERCOUNT_CHARACTERS'),'WORDS'=>JText::_('PLG_SYSTEM_METACHARACTERCOUNT_WORDS')),'version'=>$version[0]);
        if(isset($periodicals[$formname])) {
            $config['periodicals']=$periodicals[$formname];
        }
        foreach($validforms[$formname] as $key=>$fieldname) $config['fields'][$key]=$fieldname;
        $doc->addScriptDeclaration("\n".'window.plg_system_metacharactercount_config = '.json_encode($config).";\n");
        $doc->addStyleDeclaration('.metacharactercount {float:left;clear:left;}');
        return true;
    }
 }